## ondevice 0.5.1+build16

=== Makefile ===
#
# ondevice Makefile
#
# contains targets for building and packaging the ondevice CLI
#
# travis-ci.org will run `make package` (after

ARCH=$(shell uname -m)
GO_IMAGE=golang:1.9-stretch
VERSION=0.5.1

# Version suffix:
# - empty if TRAVIS_TAG is set
# - +build$n if TRAVIS_BUILD_NUMBER is set
# - "-local" otherwise
VERSION_SUFFIX:=$(if $(TRAVIS_TAG),,$(if $(TRAVIS_BUILD_NUMBER),+build$(TRAVIS_BUILD_NUMBER),-local))

all:
	@mkdir -p target/
	go build -ldflags '-X github.com/ondevice/ondevice/config.version=$(VERSION)' -o target/ondevice ondevice.go

clean:
	rm -rf target/

# prints variables and their values
vars:
	@echo 'Arch: "$(ARCH)"'
	@echo 'Version: "$(VERSION)"'
	@echo 'Suffix: "$(VERSION_SUFFIX)"'

deps:
	glide install

# builds all the release artifacts
package: package-deb package-linux build-docker


#
# ondevice/ondevice docker image
#
build-docker:
	docker build -f build/docker/Dockerfile -t ondevice/ondevice .


#
# .deb files
#
package-deb: package-deb-amd64 package-deb-i386 package-deb-armhf

package-deb-amd64:
	$(MAKE) _package-deb ARCH=amd64 GOARCH=amd64 SOURCE_IMAGE=amd64/$(GO_IMAGE)

package-deb-i386:
	$(MAKE) _package-deb ARCH=i386 GOARCH=386 SOURCE_IMAGE=i386/$(GO_IMAGE)

package-deb-armhf:
	$(MAKE) _package-deb ARCH=armhf GOARCH=arm SOURCE_IMAGE=$(GO_IMAGE) BUILD_ARGS=--host-arch=armhf


_package-deb:
	@echo "\n============\nPackaging: debian $(ARCH)\n============\n" >&2
	# builds and packages the i386,amd64 and armhf ondevice debian packages (as well as ondevice-daemon)
	docker build -f build/deb/Dockerfile '--build-arg=SOURCE_IMAGE=$(SOURCE_IMAGE)' '--build-arg=GOARCH=$(GOARCH)' '--build-arg=BUILD_ARGS=$(BUILD_ARGS)' '--build-arg=VERSION=$(VERSION)' '--build-arg=VERSION_SUFFIX=$(VERSION_SUFFIX)' -t ondevice/package-deb-$(ARCH) .

	# extract artefacts
	rm -rf 'target/deb/$(ARCH)'; mkdir -p target/deb/
	CONTAINER="$$(docker run --rm -d ondevice/package-deb-$(ARCH) sleep 60)"; docker cp "$$CONTAINER:/target" 'target/deb/$(ARCH)'

#
# Linux .tgz
#
# TODO this build runs as root (and might create the target as root breaking package-deb running later)
package-linux: package-linux-amd64 package-linux-i386 package-linux-armhf
package-linux-amd64:
	$(MAKE) _package-linux GOARCH=amd64
package-linux-armhf:
	$(MAKE) _package-linux GOARCH=arm
package-linux-i386:
	$(MAKE) _package-linux GOARCH=386

_package-linux:
	@echo "\n============\nPackaging: linux $(GOARCH)\n============\n" >&2
	docker run --rm -ti -v "$(PWD):/go/src/github.com/ondevice/ondevice/" "$(GO_IMAGE)" env GOARCH="$(GOARCH)" VERSION="$(VERSION)" VERSION_SUFFIX="$(VERSION_SUFFIX)" /go/src/github.com/ondevice/ondevice/build/linux/build.sh

=== build/deb/debian/changelog ===
ondevice (0.5.1) stable; urgency=low

  * Bugfix release:
  * Fixed issue in `ondevice login`
  * added `--batch=username` flag to `ondevice login`
  * fixed issue with `ondevice list` on 32bit systems (were using a 32bit integer for the timestamp)

 -- ondevice.io debian team <debian@ondevice.io>  Thu, 09 Nov 2017 23:21:08 +0100

ondevice (0.5) stable; urgency=low

  * added `ondevice event`
  * added support for an official [ondevice/ondevice](https://hub.docker.com/r/ondevice/ondevice) docker image
  * added tunnel state machine (to fix state transition issues)
  * updated `ondevice login` to support the new AuthKey permission model
  * refactored the way commands are implemented (improving code readability)
  * added nicer error messages for 'authentication failed' and 'rate limit exceeded'
  * doing a os.Chmod(0600) when writing ondevice.conf 
  * a lot of minor fixes and improvements

 -- ondevice.io debian team <debian@ondevice.io>  Wed, 01 Nov 2017 21:10:34 +0100

ondevice (0.4.4) stable; urgency=low

  * Debian: fixed logrotate issue
  * using [glide](https://glide.sh/) for dependency management
  * added timeout to OpenWebsocket() (fixes rare reconnect issue, see #14)
  * Config.SetValue() now recursively creates the config dir (if it doesn't exist)
  * fixed issue with ondevice ssh not properly exiting when the connection was lost (see #15)
  * fixed synchronisation issue in websocket.Write()

 -- ondevice.io debian team <debian@ondevice.io>  Sun, 02 Apr 2017 21:40:48 +0200

ondevice (0.4.3) stable; urgency=low

  * added ONDEVICE_LOG variable support (to set the log level)
  * fixed issues with closing tunnel sessions

 -- ondevice.io debian team <debian@ondevice.io>  Tue, 14 Feb 2017 12:08:04 +0200

ondevice (0.4.2) stable; urgency=low

  * fixed issue with cleanly closing connections
  * printing byte counts when connections close
  * improved certain error messages
  * some other minor improvements

 -- ondevice.io debian team <debian@ondevice.io>  Sat, 04 Feb 2017 18:31:18 +0200

ondevice (0.4.1) stable; urgency=low

  * fixed an issue that prevented the environment to be preserved when running ondevice ssh/rsync
  * x11vnc is now 'Suggested' instead of 'Recommended'
  * added logrotate config for /var/log/ondevice/ondevice.log
  * recreating /var/run/ondevice/ in the init script (was causing issues when rebooting)

 -- ondevice.io debian team <debian@ondevice.io>  Sun, 30 Jan 2017 01:49:41 +0200

ondevice (0.4.0deb1) stable; urgency=low

  * fixed Broken and Replaces directives in debian/control (to allow for a smooth transition from 0.3.1)

 -- ondevice.io debian team <debian@ondevice.io>  Sun, 30 Jan 2017 01:49:41 +0200

ondevice (0.4.0) stable; urgency=low

  * first golang based client

 -- ondevice.io debian team <debian@ondevice.io>  Sun, 29 Jan 2017 23:12:29 +0200

ondevice (0.3.1) stable; urgency=low

  * fixed some system-wide config issues
  * fixed issue with overwriting the control socket (was set up outside the FileLock)
  * explicitly calling chmod after writing to the various config files

 -- ondevice.io debian team <debian@ondevice.io>  Thu, 10 Nov 2016 13:34:07 +0200

ondevice (0.3) stable; urgency=low

  * added `ondevice.sock` UNIX socket
  * added `/state` socket endpoint (shows info about the device daemon, current connections, etc.)
  * reimplemented `ondevice status` to query `ondevice.sock` instead of making guesses about the daemon state
  * we're sending ping messages through tunnels too
  * added `--foreground` and `--configDir` arguments to `ondevice daemon`
  * added support for setting the device authentiction using environment variables (in preparation of the ondevice-daemon debian package)

 -- ondevice.io debian team <debian@ondevice.io>  Thu, 10 Nov 2016 00:24:32 +0200

ondevice (0.2.6) stable; urgency=low

  * fixed commandline parsing issue in `ondevice list`

 -- ondevice.io debian team <debian@ondevice.io>  Thu, 22 Sep 2016 14:10:57 +0200

ondevice (0.2.5) stable; urgency=low

  * added `ondevice rsync`
  * improved `ondevice ssh`'s argument parsing
  * added `--props` argument to `ondevice list`
  * improved error handling

 -- ondevice.io debian team <debian@ondevice.io>  Thu, 22 Sep 2016 13:59:31 +0200

ondevice (0.2.4) stable; urgency=low

  * Initial debian package

 -- ondevice.io debian team <debian@ondevice.io>  Sat, 17 Sep 2016 08:34:25 +0200

=== debian/changelog ===
ondevice (0.5.1+build16) UNRELEASED; urgency=medium

  * automated build

 -- builduser <user@507df3f216fd>  Thu, 04 Jan 2018 17:06:52 +0000

=== build/deb/debian/control ===
Source: ondevice
Section: python
Priority: extra
Maintainer: ondevice.io team <info@ondevice.io>
Build-Depends: debhelper (>= 6)
Standards-Version: 3.9.5

Package: ondevice
Architecture: any
Pre-Depends: dpkg (>= 1.15), ${misc:Pre-Depends}
Depends: ${misc:Depends}, openssh-client
Recommends: openssh-server
Suggests: x11vnc, rsync
Breaks: ondevice-python3.5 (<< 0.3.3), ondevice-python3.4 (<< 0.3.3), ondevice-python2.7 (<< 0.3.3), ondevice-python2.6 (<< 0.3.3)
Replaces: ondevice-python3.5 (<< 0.3.3), ondevice-python3.4 (<< 0.3.3), ondevice-python2.7 (<< 0.3.3), ondevice-python2.6 (<< 0.3.3)
Description: official ondevice.io client
 See https://ondevice.io/ for details
 .
 This is the ondevice client for debian based distributions

Package: ondevice-daemon
Architecture: all
Pre-Depends: dpkg (>= 1.15)
Depends: ondevice (= ${binary:Version})
Description: ondevice.io daemon
 Sets up `ondevice daemon` as a system daemon.
 .
 see https://ondevice.io/ for further details

=== build/deb/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_builddeb:
	# improve compatibility with older debian-compatible releases
	dh_builddeb -- -Zgzip

override_dh_strip:
	# see https://github.com/golang/go/issues/5855#issuecomment-66082174
	echo "not stripping golang binaries" >&2

## ondevice 0.5.1+build18

=== debian/changelog ===
ondevice (0.5.1+build18) UNRELEASED; urgency=medium

  * automated build

 -- builduser <user@70e28f2a1f36>  Sat, 06 Jan 2018 19:06:00 +0000
